\documentclass[aspectratio=169]{beamer}

\usepackage{subfigure}
\graphicspath{{fig/}}

\usefonttheme{serif}

\setbeamertemplate{footline}{%
  \raisebox{5pt}{\makebox[\paperwidth]{\hfill\makebox[15pt]{\scriptsize\insertframenumber}}}}
% \setbeamertemplate{footline}[frame number]{}
\setbeamertemplate{navigation symbols}{}

\usecolortheme{lily}
\setbeamercolor{block title}{bg=black!20,fg=black}
\setbeamercolor{block body}{bg = black!10, fg = black}

\setbeamercolor{itemize item}{fg = black}
\setbeamercolor{enumerate item}{fg = black}

\usetheme{default}
\useinnertheme{circles}
\beamertemplatenavigationsymbolsempty
\setbeamercolor{titlelike}{fg=black}
\setbeamercolor{section number projected}{bg=white,fg=black}

\def\labelenumi{\theenumi.}

\usepackage{caption}
\usepackage[labelfont={color=black}]{caption}
\captionsetup[figure]{labelformat=empty}
\captionsetup[table]{labelformat=empty}

\usepackage[utf8]{inputenc}
% \usepackage{sagetex}
\usepackage{dirtree}
\usepackage{relsize}
\usepackage{pdfpages}
\usepackage{bm}
\usepackage{varwidth}
\usepackage{tasks}
\usepackage{cprotect}
\usepackage[section]{placeins}
\usepackage{tikz}
\usetikzlibrary{decorations.pathreplacing, calligraphy}
\usepackage{ctable}

\usepackage{epigraph}
\renewcommand{\epigraphflush}{center}

\usepackage{tablefootnote}
\newcommand{\tf}[1]{\tablefootnote{#1}}

\usepackage{makecell}
\newcommand{\mc}[1]{\makecell{#1}}

\usepackage[binary-units=true]{siunitx}
\newcommand{\h}{\hour}
\newcommand{\MA}{\mega}
\newcommand{\GA}{\giga}
\newcommand{\B}{\byte}

\hypersetup{
  colorlinks   = true, %Colours links instead of ugly boxes
  urlcolor     = black, %Colour for external hyperlinks
  linkcolor    = black, %Colour of internal links
  citecolor   = black %Colour of citations
}

\usepackage[section]{algorithm}
\usepackage[noend]{algpseudocode}

\usepackage{graphicx}
\usepackage{chngcntr}

\usepackage{mathtools}
\DeclarePairedDelimiter\abs{\lvert}{\rvert}

\usepackage{amsthm}
\usepackage{amssymb}
\numberwithin{equation}{section}
\newcommand{\Fx}[2][n]{\mathbb{F} \! \left[ #2_1, \ldots, #2_#1 \right]}
\newcommand{\F}{\mathbb{F}}
\newcommand{\R}{\mathbb{R}}
\newcommand{\E}{\mathbb{E}}
\newcommand{\Nat}{\mathbb{N}}
\newcommand{\Prime}{\mathbb{P}}
\newcommand{\N}{\mathbb{N}}
\newcommand{\mb}[1]{\mathbf{#1}}
\newcommand{\Fg}{\F[\mb{x}]}
\newcommand{\M}{\mathcal{M}}
\newcommand{\Mx}{\mathcal{M}(\mb{x})}
\newcommand{\s}[2][n]{#2_1, \ldots, #2_{#1}}
\newcommand{\sn}[2][n]{\left( \s[#1]{#2} \right)}
\newcommand{\n}[2][n]{\! \sn[#1]{#2}}
\newcommand{\LT}[1]{\mathrm{LT}(#1)}
\newcommand{\LC}[1]{\mathrm{LC}(#1)}
\newcommand{\LM}[1]{\mathrm{LM}(#1)}
\newcommand{\lcm}[1]{\mathrm{lcm}(#1)}
\newcommand{\Min}[1]{\mathrm{min}(#1)}
\newcommand{\dg}[1]{\mathrm{deg}(#1)}
\newcommand{\sdel}{\ \middle | \ }
\newcommand{\lex}{\succeq_{lex}}

\newtheorem{thm}[subsection]{Theorem}
\newtheorem{pr}[subsection]{Proposition}
\newtheorem{lm}[subsection]{Lemma}

\newtheoremstyle{dfstyle}% % Name
  {}%                      % Space above
  {}%                      % Space below
  {}%                      % Body font
  {}%                      % Indent amount
  {\bfseries}%             % Theorem head font
  {.}%                     % Punctuation after theorem head
  { }%                     % Space after theorem head, ' ', or \newline
  {\thmname{#1}\thmnumber{ #2}\thmnote{ (#3)}}

\theoremstyle{dfstyle}
\newtheorem{df}[subsection]{Definition}

\theoremstyle{definition}
\newtheorem{e}[subsection]{Example}
\newtheorem{re}[subsection]{Remark}

\newtheoremstyle{break}% name
  {}% Space above, empty = `usual value'
  {}% Space below
  {}% Body font
  {}% Indent amount (empty = no indent, \parindent = para indent)
  {\bfseries}% Thm head font
  {.}% Punctuation after thm head
  {\newline}% Space after thm head: \newline = linebreak
  {}%  Thm head spec

\theoremstyle{break}
% \newtheorem{examples}[subsection]{Example}

\newenvironment{es}[1][]{%
\begin{examples}[#1]\leavevmode\vspace{-\baselineskip}%
}{\end{examples}}

\newenvironment{p}[1][\proofname]{%
  \proof[\normalfont{\bfseries #1}]%
}{\endproof}

\newenvironment{ps}[1][\proofname]{%
  \proof[\normalfont{\bfseries #1}]\leavevmode\vspace{-\topskip}%
}{\endproof}

\DeclarePairedDelimiter\set\{\}

\usepackage[shortcuts]{extdash}

\def\uv#1{\char92\relax #1\char34\relax}

\newcommand\Department{Department of Information Security}
\newcommand\Faculty{Faculty of Information Technology}
\newcommand\University{Czech Technical University in Prague}
\newcommand\FacultyAndUniversityAbbr{FIT CTU}

\subject{SUBJECT}
\author{Marek Bielik \and Martin Jureček \and Olha Jurečková \and
  Róbert Lórencz \newline\newline
  \href{mailto:mail@marek.onl}{\texttt{mail@marek.onl}}
}

\title{Yet Another Algebraic Cryptanalysis of Small Scale Variants of AES}
\institute[\FacultyAndUniversityAbbr]{\Department\\ \Faculty\\ \University}
\date{\today}

\begin{document}

\begin{frame}[plain]
\titlepage
\end{frame}

\begin{frame}
\frametitle{Outline}
\tableofcontents
\end{frame}

\section{Algebraic Cryptanalysis \& Gröbner Bases}
\begin{frame}
  \frametitle{Algebraic Cryptanalysis}
  \setbeamertemplate{enumerate items}[default]
  \begin{enumerate}
  \item Express the given cipher as a system of multivariate polynomials. \itemsep=1em
  \item Optionally preprocess the polynomial system so that it is easier to
    solve.
  \item Solve the polynomial system in order to obtain the secret key.
  \end{enumerate}
\end{frame}

\subsection*{Gröbner Bases}

\begin{frame}
  \frametitle{An Example of a Gröbner Basis}
  Consider a system of equations where $f_1 = f_2 = f_3 = 0$ are polynomials in $\R
  \! \left[ x, y, z \right]$ with
  \begin{align*}
    f_1 &= -16 x^2 - 4 x y^2 + 4 x z, \\
    f_2 &= 4 x^2 z + 2 x y^2 z + z, \\
    f_3 &= x y^2 + 2 y^2 z + 1. \\
  \end{align*}
  If we compute the reduced Gröbner basis with $z \succeq_{lex} y \succeq_{lex}
  x$, we get the following polynomials:
  \begin{align*}
    g_1 &= x + \frac{1}{4} y^2 - \frac{1}{4} z, & g_2 &= y^4 - z^2 - 4, \\
    g_3 &= y^2 z - \frac{1}{9} z^2, & g_4 &= z^3 + \frac{81}{20} z.
  \end{align*}
\end{frame}

% \begin{frame}
%   \frametitle{Gröbner Bases Examples}
%   Consider a system of equations where $f_1 = f_2 = f_3 = 0$ are polynomials in
%   GF(2)$\left[ x, y, z \right]$ with
%   \begin{align*}
%     f_1 &= x + y + z, \\
%     f_2 &= x y + x z + y z, \\
%     f_3 &= x y z + 1. \\
%   \end{align*}
%   If we compute the reduced Gröbner basis with $z \succeq_{lex} y \succeq_{lex}
%   x$, we get the following polynomials:
%   \begin{align*}
%     g_1 &= x + y + z, \\
%     g_2 &= y^2 + y z + z^2, \\
%     g_3 &= z^3 + 1. \\
%   \end{align*}
% \end{frame}

\section{AES as a System of Polynomial Equations}
\subsection*{The AES as a system of polynomial equations}

% \begin{frame}
%   \frametitle{High Level Overview of AES}
%   \begin{algorithm}[H]
%     \caption{AES}\label{alg:aes}

%     \begin{tabular}{ l l }
%       \textbf{Input:}  & $\bm{\mathit{plaintext}}$ --- array of 16 bytes, \\
%                        & $\bm{\mathit{key}}$ --- array of 16 bytes \\
%       \textbf{Output:} & ciphertext $\bm{\mathit{state}}$ --- array of 16 bytes \\
%     \end{tabular}
%     \\
%     \begin{algorithmic}[1]
%       \Function{AES}{$\mathit{plaintext}$, $\mathit{key}$}
%       \State $\mathit{expKey} \gets$ ExpandKey($\mathit{key}$)
%       \State $\mathit{state} \gets \mathit{plaintext}$
%       \State $\mathit{state} \gets$ AddRoundKey($\mathit{state}$, $\mathit{expKey}[0 : 3]$)

%       \For{$\mathit{round} \gets 1$ to 9}
%       \State $\mathit{state} \gets$ MixColumns(ShiftRows(SubBytes($\mathit{state}$)))
%       \State $\mathit{state} \gets$ AddRoundKey($\mathit{state}$,
%       $\mathit{expKey}[4 \cdot \mathit{round} : 4 \cdot (\mathit{round} + 1) - 1]$)
%       \EndFor

%       \State $\mathit{state} \gets$ ShiftRows(SubBytes($\mathit{state}$))
%       \State $\mathit{state} \gets$ AddRoundKey($\mathit{state}$, $\mathit{expKey}[40 : 43]$)

%       \State \Return $state$
%       \EndFunction
%     \end{algorithmic}
%   \end{algorithm}
% \end{frame}

\begin{frame}
  \frametitle{AES State and its Small Scale Variants}
  % \begin{figure}[h]
  %   \centering
  %   \includegraphics[width=.8\textwidth]{sbox}
  % \end{figure}
  $\bullet$ SR($n$, $r=4$, $c=4$, $e$):

  \centering
    \begin{tikzpicture}[scale=.9]
      \draw [line width=1pt, decorate,
      decoration={calligraphic brace, raise=1ex, amplitude=2ex}]         (0,4) --  (4,4)
      node[pos=0.5, above=3ex]{$c = 4$};
      \draw [line width=1pt, decorate,
      decoration={calligraphic brace, raise=1ex, amplitude=2ex, mirror}] (4,0) --  (4,4)
      node[pos=0.5, right=3ex]{$r = 4$};

      \draw (0,3) rectangle node {\large$s_{0}$} +(1,1);
      \draw (0,2) rectangle node {\large$s_{1}$} +(1,1);
      \draw (0,1) rectangle node {\large$s_{2}$} +(1,1);
      \draw (0,0) rectangle node {\large$s_{3}$} +(1,1);
      \draw (1,3) rectangle node {\large$s_{4}$} +(1,1);
      \draw (1,2) rectangle node {\large$s_{5}$} +(1,1);
      \draw (1,1) rectangle node {\large$s_{6}$} +(1,1);
      \draw (1,0) rectangle node {\large$s_{7}$} +(1,1);
      \draw (2,3) rectangle node {\large$s_{8}$} +(1,1);
      \draw (2,2) rectangle node {\large$s_{9}$} +(1,1);
      \draw (2,1) rectangle node {\large$s_{10}$} +(1,1);
      \draw (2,0) rectangle node {\large$s_{11}$} +(1,1);
      \draw (3,3) rectangle node {\large$s_{12}$} +(1,1);
      \draw (3,2) rectangle node {\large$s_{13}$} +(1,1);
      \draw (3,1) rectangle node {\large$s_{14}$} +(1,1);
      \draw (3,0) rectangle node {\large$s_{15}$} +(1,1);

      \draw (2,0) node[below=2ex, align=center]
      {{\large$s_i\,$}$\in \text{GF}(2^8)$ for $e = 8$ \\[1ex]
        {\large$s_i\,$}$\in \text{GF}(2^4)$ for $e = 4$ \\[1ex]
      $n \in 1,\ldots,10$};
    \end{tikzpicture}
\end{frame}

% \begin{frame}
%   \frametitle{Shift Rows in AES}
%   \begin{figure}[h]
%     \centering
%     \includegraphics[width=.8\textwidth]{shiftrows}
%   \end{figure}
% \end{frame}

% \begin{frame}
%   \frametitle{Mix Columns operation in AES}
%   \begin{figure}[h]
%     \centering
%     \includegraphics[width=.8\textwidth]{mixcolumns}
%   \end{figure}
% \end{frame}

% \begin{frame}
%   \frametitle{S-box in AES}
%   \begin{enumerate}[label=(\roman*)]
%   \item Take the multiplicative inverse in GF($2^4$), the element $0_{16}$ is
%     mapped to itself.
%   \item Apply the following affine transformation over GF($2^4$):
%     \begin{equation}
%       \begin{pmatrix}
%         b_0' \\
%         b_1' \\
%         b_2' \\
%         b_3'
%       \end{pmatrix}
%       =
%       \begin{pmatrix}
%         1 & 0 & 1 & 1 \\
%         1 & 1 & 0 & 1 \\
%         1 & 1 & 1 & 0 \\
%         0 & 1 & 1 & 1
%       \end{pmatrix}
%       \begin{pmatrix}
%         b_0 \\
%         b_1 \\
%         b_2 \\
%         b_3
%       \end{pmatrix}
%       +
%       \begin{pmatrix}
%         0 \\
%         1 \\
%         1 \\
%         0
%       \end{pmatrix}
%       .
%     \end{equation}
%   \end{enumerate}
% \end{frame}

\begin{frame}
  \frametitle{S-box as a System of Polynomial Equations}
  \begin{block}{Operation}
    Take the multiplicative inverse in GF($2^4$), the element $0_{16}$ is mapped
    to itself.
  \end{block}

  \begin{block}{Equations}
    Let $b = \sum_{i = 0}^{3} b_i x^i$ and $c = \sum_{i = 0}^{3} c_i x^i$ be polynomials
    in GF(2)[$x$]. The product $bc$ modulo the polynomial $m(x) = x^4 + x + 1$ is
    $r(x) = r_3 x^3 + r_2 x^2 + r_1 x + r_0$ where
    \begin{equation*}
      \begin{aligned}
        r_0 &= b_0 c_0 \oplus b_3 c_1 \oplus b_2 c_2 \oplus b_1 c_3, \\
        r_1 &= b_1 c_0 \oplus b_0 c_1 \oplus b_3 c_2 \oplus b_2 c_3 \oplus b_3 c_1 \oplus b_2 c_2 \oplus b_1 c_3, \\
        r_2 &= b_2 c_0 \oplus b_1 c_1 \oplus b_0 c_2 \oplus b_3 c_3 \oplus b_3 c_2 \oplus b_2 c_3, \\
        r_3 &= b_3 c_0 \oplus b_2 c_1 \oplus b_1 c_2 \oplus b_0 c_3 \oplus b_3 c_3.
      \end{aligned}
    \end{equation*}
    We have $bc = r = 1$ so that $r_0 = 1$ and $r_i = 0$ for $i = 1, 2, 3$.
  \end{block}
\end{frame}

\begin{frame}
  \frametitle{Eliminating Auxiliary Variables}

  {\large
    \begin{align*}
      f_1 &= c_0 \oplus b_2 b_1 b_0 \oplus b_3 b_2 b_1 \oplus b_2 b_0 \oplus b_2 b_1 \oplus b_0 \oplus b_1 \oplus b_2 \oplus b_3, \\
      f_2 &= c_1 \oplus b_3 b_1 b_0 \oplus b_1 b_0 \oplus b_2 b_0 \oplus b_2 b_1 \oplus b_3 b_1 \oplus b_3, \\
      f_3 &= c_2 \oplus b_3 b_2 b_0 \oplus b_1 b_0 \oplus b_2 b_0 \oplus b_3 b_0 \oplus b_2 \oplus b_3, \\
      f_4 &= c_3 \oplus b_3 b_2 b_1 \oplus b_3 b_0 \oplus b_3 b_1 \oplus b_3 b_2 \oplus b_1 \oplus b_2 \oplus b_3, \\\\
      f_5 &= b_3 b_2 b_1 b_0 \oplus b_2 b_1 b_0 \oplus b_3 b_1 b_0 \oplus b_3 b_2 b_0 \oplus b_3 b_2 b_1 \oplus b_1 b_0 \oplus b_2 b_0 \oplus b_2 b_1 \oplus b_3 b_0 \\
         & \quad \quad \quad \quad \quad\! \oplus b_3 b_1 \oplus b_3 b_2 \oplus b_0 \oplus b_1 \oplus b_2 \oplus b_3 \oplus 1
    \end{align*}
  }
\end{frame}

% \begin{frame}
%   \frametitle{S-box as a system of polynomial equations} Let $L_s$ denote the
%   matrix for the linear transformation in an S-box. In order to describe the
%   whole \emph{SubBytes} operation, we can extend the matrix $L_s$ to the whole
%   state array of the cipher, so we have the matrix
%   \begin{equation*}
%     L =
%     \begin{pmatrix}
%       L_s & 0 & 0 & 0 \\
%       0 & L_s & 0 & 0 \\
%       0 & 0 & L_s & 0 \\
%       0 & 0 & 0 & L_s
%     \end{pmatrix}.
%   \end{equation*}
% \end{frame}

% \begin{frame}
%   \frametitle{Shift Rows}
%   \begin{equation*}
%     R =
%     \begin{pmatrix}
%       I_4 & 0 & 0 & 0 \\
%       0 & 0 & 0 & I_4 \\
%       0 & 0 & I_4 & 0 \\
%       0 & I_4 & 0 & 0
%     \end{pmatrix}
%   \end{equation*}
% \end{frame}

% \begin{frame}
%   \frametitle{Mix Columns}
%   \begin{equation*}
%     \label{eq:small_mixcol}
%     \begin{pmatrix}
%       s_{0,j}' \\
%       s_{1,j}'
%     \end{pmatrix}
%     =
%     \begin{pmatrix}
%       x + 1 &   x   \\
%       x   & x + 1
%     \end{pmatrix}
%     \begin{pmatrix}
%       s_{0,j} \\
%       s_{1,j}
%     \end{pmatrix}
%   \end{equation*}

%   \[
%     M_{x+1} =
%     \begin{pmatrix}
%       1 & 0 & 0 & 1 \\
%       1 & 1 & 0 & 1 \\
%       0 & 1 & 1 & 0 \\
%       0 & 0 & 1 & 1
%     \end{pmatrix}
%     \qquad  \qquad
%     M_x =
%     \begin{pmatrix}
%       0 & 0 & 0 & 1 \\
%       1 & 0 & 0 & 1 \\
%       0 & 1 & 0 & 0 \\
%       0 & 0 & 1 & 0
%     \end{pmatrix}
%   \]
%   \begin{equation*}
%     M =
%     \begin{pmatrix}
%       M_{x+1} &   M_x  &   0   &   0   \\
%       M_x  & M_{x+1} &   0   &   0   \\
%       0   &   0   & M_{x+1} &  M_x   \\
%       0   &   0   &  M_x   & M_{x+1}
%     \end{pmatrix}
%   \end{equation*}
% \end{frame}

\begin{frame}
  \frametitle{One Round of AES}
  We can describe one round of AES by
  {\Large
    \[
      \mathbf{b_i} = MR\overbrace{(L \mathbf{b_{i-1}^{-1}} + \mathbf{6})}^{\text{full S-box}} + \mathbf{k_i} \quad
      \text{for} \quad \overbrace{0 < i \le n}^{\text{rounds}}
    \]
  } where (simplified):
  \begin{itemize}
  \item $\mathbf{b_0}$ is the plaintext \texttt{XOR}ed with the initial key, note
    that we only use this as the input to the S-box, \itemsep=1ex
  \item $\mathbf{b_n}$ is the ciphertext,
  \item $M, R, L$ are matrices representing linear transformations in the
    cipher, these matrices have entries in GF(2),
  \item $\mathbf{b_{i-1}^{-1}}$ is the output from the S-box
    inversion,
  \item $\mathbf{k_i}$ is the key material for round $i$.
  \end{itemize}

  % \[
  %   \mathbf{b_i} = MRL \mathbf{b_{i-1}^{-1}} + \mathbf{k_i} + \mathbf{6} \quad
  %   \text{for} \quad 0 < i \le n
  % \]

  % Let $\mathbf{k}_{\mathbf{i}} = \left( k_{i,0}, k_{i,1}, k_{i,2}, k_{i,3},
  % \right)^T \in GF(2^4)^4$ be the round key of round $i$. The round key can be
  % then defined by
  % \[
  %   \begin{pmatrix}
  %     k_{i,2q} \\
  %     k_{i,2q+1}
  %   \end{pmatrix}
  %   =
  %   \begin{pmatrix}
  %     L k_{i-1,3}^{-1} \\
  %     L k_{i-1,2}^{-1}
  %   \end{pmatrix}
  %   +
  %   \begin{pmatrix}
  %     6_{16} \\
  %     6_{16}
  %   \end{pmatrix}
  %   +
  %   \begin{pmatrix}
  %     x^{i-1} \\
  %     0
  %   \end{pmatrix}
  %   +
  %   \sum_{t=0}^{q}
  %   \begin{pmatrix}
  %     k_{i-1,2t} \\
  %     k_{i-1,2t+1}
  %   \end{pmatrix}
  % \]
  % for $0 \le q < 2$ where $x^{i-1}$ is an element of GF($2^4$).
\end{frame}


\section{Results}

% \begin{frame}
%   \frametitle{Results of Experiments}
%   \setlength{\epigraphwidth}{0.8\textwidth}

%   \epigraph{``Computers are useless.
%     They can only give you answers.''}{Pablo Picasso\\
%     The Paris Review 32}
% \end{frame}

% \begin{frame}
%   \begin{scriptsize}
%     \begin{table}[h]
%       \catcode`\-=12
%       \centering
%       \caption*{Initial experiments with systems containing auxiliary variables.}
%       \begin{tabular}{c c c c c c c }
%         \toprule
%         Cipher & \mc{Key \\ bits} & Vars & Polys & \multicolumn{2}{c}{F4} & SAT  \\
%         \cmidrule(rl){5-6} \cmidrule(rl){7-7}
%                &                 &      &       & Time & Mem.   & Time \\
%         \midrule
%         SR(1, 2, 2, 4)  & 16  & 72  & 120  & \SI{1}{\s}  & \SI{33}{\MA\B}  & \SI{2}{\s}    \\
%         SR(2, 2, 2, 4)  & 16  & 128 & 224  & \SI{19}{\s} & \SI{848}{\MA\B} & \SI{12}{\s}   \\
%         SR(3, 2, 2, 4)  & 16  & 184 & 328  & \SI{4}{\h}  & \SI{76}{\GA\B}  & \SI{17}{\s}   \\
%         SR(4, 2, 2, 4)  & 16  & 240 & 432  &     ---     &       ---       & \SI{27}{\s}   \\
%         SR(10, 2, 2, 4) & 16  & 576 & 1056 &     ---     &       ---       & \SI{50}{\s}   \\

%         SR(1, 4, 2, 4)  & 32  & 144 & 240  & \SI{48}{\s} & \SI{981}{\MA\B} & \SI{9}{\s}    \\
%         SR(2, 4, 2, 4)  & 32  & 256 & 448  &     ---     &       ---       & \SI{1.5}{\m}  \\
%         SR(3, 4, 2, 4)  & 32  & 368 & 656  &     ---     &       ---       & \SI{63}{\h}  \\

%         SR(1, 2, 4, 4)  & 32  & 136 & 216  & \SI{3}{\s}  & \SI{67}{\MA\B}  & \SI{11}{\s}   \\
%         SR(2, 2, 4, 4)  & 32  & 240 & 400  &     ---     &       ---       & \SI{33}{\s}   \\
%         SR(3, 2, 4, 4)  & 32  & 344 & 584  &     ---     &       ---       & \SI{15.5}{\m} \\
%         SR(4, 2, 4, 4)  & 32  & 448 & 768  &     ---     &       ---       & \SI{34}{\h}   \\

%         SR(1, 4, 4, 4)  & 64  & 272 & 432  &     ---     &       ---       & \SI{2.5}{\m}  \\

%         SR(1, 2, 2, 8)  & 32  & 144 & 240  & \SI{1}{\m}  & \SI{2.2}{\GA\B} & \SI{22}{\s}   \\
%         SR(2, 2, 2, 8)  & 32  & 256 & 448  &     ---     &       ---       & \SI{11.5}{\m} \\

%         SR(1, 4, 2, 8)  & 64  & 288 & 480  &     ---     &       ---       & \SI{41.5}{\m} \\

%         SR(1, 2, 4, 8)  & 64  & 272 & 432  &     ---     &       ---       & \SI{4}{\m}    \\

%         SR(1, 4, 4, 8)  & 128 & 544 & 864  &     ---     &       ---       & ---           \\
%         \bottomrule
%       \end{tabular}
%     \end{table}
%   \end{scriptsize}
% \end{frame}

% \begin{frame}
%   \begin{small}
%   \ctable[
%   caption = Experiments with systems with no auxiliary variables.,
%   label = tab:key,
%   pos = h,
%   ]{c c c c c c c}{
%     \tnote[a]{Preprocessing Time --- the time required to obtain the system}
%     \tnote[b]{Average number of Monomials per Polynomial}
%   }{
%     \FL
%     Cipher & \mc{Key \\ bits} & PT \tmark[a] & AMP \tmark[b] & \multicolumn{2}{c}{F4} & SAT \NN
%     \cmidrule(rl){5-6} \cmidrule(rl){7-7}
%            &                 &              &                & Time & Mem.   & Time
%     \ML
%     SR(1, 2, 2, 4)  & 16 & \SI{1}{\s}   & 20    & \SI{1}{\s}   & \SI{33}{\MA\B}   & \SI{1}{\s}   \NN
%     SR(2, 2, 2, 4)  & 16 & \SI{1}{\s}   & 2475  & \SI{2.5}{\m} & \SI{4.8}{\GA\B}  & \SI{1}{\m}   \NN
%     SR(3, 2, 2, 4)  & 16 & \SI{8}{\s}   & 32784 & \SI{8.5}{\m} & \SI{18.5}{\GA\B} & \SI{13}{\m}  \NN
%     SR(10, 2, 2, 4) & 16 & \SI{2.5}{\m} & 32814 & \SI{9}{\m}   & \SI{19.5}{\GA\B} & \SI{14}{\m}  \NN

%     SR(1, 4, 2, 4)  & 32 & \SI{1}{\s}   & 37    & \SI{55}{\s}  & \SI{1.2}{\GA\B}  & \SI{1}{\s}   \NN

%     SR(1, 2, 4, 4)  & 32 & \SI{1}{\s}   & 23    & \SI{13}{\s}  & \SI{671}{\MA\B } & \SI{1}{\s}   \NN

%     SR(1, 4, 4, 4)  & 64 & \SI{4}{\s}   & 40    & ---          & ---              & \SI{2}{\m}   \NN

%     SR(1, 2, 2, 8)  & 32 & \SI{8}{\s}   & 314   & ---          & ---              & \SI{1.5}{\m} \NN

%     SR(1, 4, 2, 8)  & 64 & \SI{18}{\s}  & 567   & ---          & ---              & \SI{33}{\m}  \NN

%     SR(1, 2, 4, 8)  & 64 & \SI{14}{\s}  & 348   & ---          & ---              & \SI{1.5}{\h}
%     \LL
%   }
% \end{small}
% \end{frame}

\begin{frame}
  \frametitle{Combining Multiple Systems}
  \setbeamertemplate{enumerate items}[default]
  \begin{enumerate}
  \item Let $\{\s[k]{f}\}$ and $\{\s[k]{g}\}$ be two polynomial systems
    generated from two different pairs of plaintext and ciphertext under the
    same key $\mathbf{k}$. \itemsep=1em
  \item Since each $f_i \! \left( \mathbf{k} \right) = 0$ and $g_j \! \left(
      \mathbf{k} \right) = 0$, we have $I = \langle \s[k]{f}, \s[k]{g} \rangle
    \subseteq I(\mathbf{k})$.
  \item We can now compute the Gröbner basis for $I$ and we still get the
    initial key $\mathbf{k}$.
  \end{enumerate}

  % In general, in order to obtain the ideal $I$, we may combine any number of
  % polynomial systems instead of two. The ideal $I$ represents an overdefined
  % system for which it could be easier to obtain the solution. We will call one
  % pair of plaintext and its corresponding ciphertext a \textbf{PC pair}. In
  % our further experiments, we assume that all PC pairs use the same key.
\end{frame}

\begin{frame}
  \begin{footnotesize}
  \ctable[
  caption = Experiments with two combined systems.,
  label = tab:combo,
  pos = h,
  ]{c c c c c c c}{
    \tnote[a]{Preprocessing Time --- the time required to obtain the system}
    \tnote[b]{Average number of Monomials per Polynomial}
  }{
    \FL
    Cipher & \mc{Key \\ bits} & PT \tmark[a] & AMP \tmark[b] & \multicolumn{2}{c}{F4} & SAT \NN
    \cmidrule(rl){5-6} \cmidrule(rl){7-7}
           &                 &              &               & Time & Mem.   & Time
    \ML
    SR(1, 2, 2, 4)  & 16  & \SI{1}{\s}  & 21    & \SI{1}{\s}  & \SI{33}{\MA\B}   & \SI{1}{\s}    \NN
    SR(2, 2, 2, 4)  & 16  & \SI{2}{\s}  & 2469  & \SI{5}{\s}  & \SI{100}{\MA\B}  & \SI{1}{\m}    \NN
    SR(3, 2, 2, 4)  & 16  & \SI{9}{\s}  & 32798 & \SI{13}{\m} & \SI{19.8}{\GA\B} & \SI{45.5}{\m} \NN
    SR(10, 2, 2, 4) & 16  & \SI{3}{\m}  & 32774 & \SI{11}{\m} & \SI{25.5}{\GA\B} & \SI{31.5}{\m} \NN

    SR(1, 4, 2, 4)  & 32  & \SI{2}{\s}  & 37    & \SI{1}{\s}  & \SI{33}{\MA\B}   & \SI{1}{\s}    \NN
    SR(2, 4, 2, 4)  & 32  & \SI{6}{\s}  & 33360 & ---         & ---              & ---           \NN

    SR(1, 2, 4, 4)  & 32  & \SI{2}{\s}  & 23    & \SI{1}{\s}  & \SI{33}{\MA\B}   & \SI{1}{\s}    \NN
    SR(2, 2, 4, 4)  & 32  & \SI{3}{\s}  & 6701  & ---         & ---              & ---           \NN

    SR(1, 4, 4, 4)  & 64  & \SI{4}{\s}  & 39    & \SI{1}{\s}  & \SI{33}{\MA\B}   & \SI{2}{\s}    \NN

    SR(1, 2, 2, 8)  & 32  & \SI{10}{\s} & 316   & \SI{1}{\s}  & \SI{33}{\MA\B}   & \SI{8}{\s}    \NN

    SR(1, 4, 2, 8)  & 64  & \SI{18}{\s} & 568   & \SI{2}{\s}  & \SI{33}{\MA\B}   & \SI{17}{\s}   \NN

    SR(1, 2, 4, 8)  & 64  & \SI{15}{\s} & 348   & \SI{1}{\s}  & \SI{33}{\MA\B}   & \SI{17}{\s}   \NN

    SR(1, 4, 4, 8)  & 128 & \SI{34}{\s} & 599   & \SI{4}{\s}  & \SI{33}{\MA\B}   & \SI{35}{\s}
    \LL
}
\end{footnotesize}
\end{frame}

\begin{frame}
  \begin{footnotesize}
  \ctable[
  caption = Experiments with reduced polynomial systems.,
  label = tab:red,
  pos = h,
  ]{c c c c c c c c}{
    \tnote[a]{Preprocessing Time --- the time required to obtain the system}
    \tnote[b]{Average number of Monomials per Polynomial after Reduction}
    \tnote[c]{Number of polynomial systems for reduction}
  }{
    \FL
    Cipher & \mc{Key \\ bits} & PT \tmark[a] & AMPR \tmark[b]  & $l$ \tmark[c] & \multicolumn{2}{c}{F4} & SAT \NN
    \cmidrule(rl){6-7} \cmidrule(rl){8-8}
           &                  &              &                 &               & Time & Mem.            & Time
    \ML
    SR(2, 2, 2, 4) & 16 & \SI{5}{\s}  & 601   & 1 & \SI{1}{\s}  & \SI{33}{\MA\B}   & \SI{29}{\s}   \NN
    SR(2, 2, 2, 4) & 16 & \SI{5}{\s}  & 519   & 5 & \SI{1}{\s}  & \SI{33}{\MA\B}   & \SI{24}{\s}   \NN
    \midrule[0.01ex]
    SR(3, 2, 2, 4) & 16 & \SI{25}{\s} & 32592 & 1 & \SI{16}{\m} & \SI{17.9}{\GA\B} & \SI{37.5}{\m} \NN
    SR(3, 2, 2, 4) & 16 & \SI{40}{\s} & 32555 & 5 & \SI{18}{\m} & \SI{23.1}{\GA\B} & \SI{41}{\m}   \NN
    \midrule[0.01ex]
    SR(2, 4, 2, 4) & 32 & \SI{26}{\s} & 4938  & 1 & ---           & ---                & ---           \NN
    SR(2, 4, 2, 4) & 32 & \SI{1}{\m}  & 4563  & 5 & ---           & ---                & ---           \NN
    \midrule[0.01ex]
    SR(2, 2, 4, 4) & 32 & \SI{14}{\s} & 3410  & 1 & ---           & ---                & \SI{83}{\m}   \NN
    SR(2, 2, 4, 4) & 32 & \SI{18}{\s} & 1192  & 5 & \SI{60}{\m} & \SI{34.5}{\GA\B} & \SI{50}{\m}
    \LL
  }
\end{footnotesize}
\end{frame}

\begin{frame}
  \begin{figure}[h]
    \centering
    \includegraphics[width=.7\textwidth]{2424}
    \caption*{Frequencies of the key variables for five instances of SR(2, 4, 2,
      4). The variables are ordered according to their frequency.}
  \end{figure}
\end{frame}

\begin{frame}
  \begin{footnotesize}
      \ctable[
      caption = Experiments with reduced polynomial systems and brute-forced variables.,
      label = tab:guess,
      pos = h,
      ]{c c c c c c}{
        \tnote[a]{Preprocessing Time --- the time required to obtain the system}
      }{
        \FL
        Cipher & \mc{Key \\ bits} & PT \tmark[a] &  \multicolumn{2}{c}{F4} & SAT \NN
        \cmidrule(rl){4-5} \cmidrule(rl){6-6}
        &                 &              &  Time & Mem.   & Time
        \ML
        SR(3, 2, 2, 4) & 16 & \SI{8}{\m}   & \SI{6}{\s}  & \SI{33}{\MA\B}  & \SI{35}{\s} \NN

        SR(2, 4, 2, 4) & 32 & \SI{2.5}{\m} & \SI{43}{\s} & \SI{620}{\MA\B} & \SI{9}{\m}  \NN

        SR(2, 2, 4, 4) & 32 & \SI{31}{\s}  & \SI{14}{\s} & \SI{72}{\MA\B}  & \SI{5.5}{\m}
        \LL
      }
  \end{footnotesize}
\end{frame}

\begin{frame}
  \frametitle{Our Work Contains}
  \setbeamertemplate{enumerate items}[default]
  \begin{enumerate}
  \item Description of how Gröbner bases can be utilized in the cryptanalysis of
    AES. \itemsep=1em
  \item Derivation and implementation of algebraic models of AES based only on
    the variables of the initial key.
  \item Proposal and demonstration of various approaches to preprocess the
    polynomial systems before solving them.
  \item Analysis of the diffusion in small scale variants of AES.
  \item Effective break of one round of AES-128.
  \item Comparison between solving polynomial systems by Gröbner bases and a SAT
    solver (F4 in Magma and CryptoMiniSAT).
  \end{enumerate}
\end{frame}

\begin{frame}[c]
  \begin{center}
    \vfill
    {\tiny The authors acknowledge the support of the OP VVV funded project
      CZ.02.1.01/0.0/0.0/16\_019/0000765 ''Research Center for Informatics''.}

    \begin{figure}[hbtp]
      \centering
      \includegraphics[width=\textwidth]{RCI_Required-logos_combined_EN}
    \end{figure}
  \end{center}
\end{frame}
\end{document}
